/* 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is the Netscape Portable Runtime library.
 * 
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are 
 * Copyright (C) 1994-2000 Netscape Communications Corporation.  All
 * Rights Reserved.
 * 
 * Contributor(s):  Silicon Graphics, Inc.
 * 
 * Portions created by SGI are Copyright (C) 2000-2001 Silicon
 * Graphics, Inc.  All Rights Reserved.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL"), in which case the provisions of the GPL are applicable 
 * instead of those above.  If you wish to allow use of your 
 * version of this file only under the terms of the GPL and not to
 * allow others to use your version of this file under the MPL,
 * indicate your decision by deleting the provisions above and
 * replace them with the notice and other provisions required by
 * the GPL.  If you do not delete the provisions above, a recipient
 * may use your version of this file under either the MPL or the
 * GPL.
 */

/*
 * This file is derived directly from Netscape Communications Corporation,
 * and consists of extensive modifications made during the year(s) 1999-2000.
 */

#ifndef __ST_SG_H__
#define __ST_SG_H__


/*****************************************
 * Platform specifics
 */

#if defined (AIX)

#define MD_STACK_GROWS_DOWN

#elif defined (CYGWIN)

#define MD_STACK_GROWS_DOWN

#elif defined (DARWIN)

#define MD_STACK_GROWS_DOWN

#elif defined (FREEBSD)

#define MD_STACK_GROWS_DOWN

#elif defined (HPUX)

#define MD_STACK_GROWS_UP

#elif defined (IRIX)

#define MD_STACK_GROWS_DOWN

#elif defined (LINUX)

#if defined(__ia64__)
#define MD_STACK_GROWS_DOWN

#elif defined(__mips__)
#define MD_STACK_GROWS_DOWN

#else /* Not IA-64 or mips */

#if defined(__powerpc__)
#define MD_STACK_GROWS_DOWN

#elif defined(__alpha)
#define MD_STACK_GROWS_DOWN

#elif defined(__mc68000__)
#define MD_STACK_GROWS_DOWN

#elif defined(__sparc__)
#define MD_STACK_GROWS_DOWN

#elif defined(__i386__)
#define MD_STACK_GROWS_DOWN

#elif defined(__amd64__) || defined(__x86_64__)
#define MD_STACK_GROWS_DOWN

#elif defined(__arm__)
#define MD_STACK_GROWS_DOWN

#elif defined(__s390__)
#define MD_STACK_GROWS_DOWN

#elif defined(__hppa__)
#define MD_STACK_GROWS_UP

#else
#error "Unknown CPU architecture"
#endif /* Cases with common MD_INIT_CONTEXT and different SP locations */

#endif /* Cases with different MD_INIT_CONTEXT */

#elif defined (NETBSD)

#define MD_STACK_GROWS_DOWN

#elif defined (OPENBSD)

#define MD_STACK_GROWS_DOWN

#elif defined (OSF1)

#define MD_STACK_GROWS_DOWN

#elif defined (SOLARIS)

#define MD_STACK_GROWS_DOWN

#elif defined (WIN32)	/* From st-win32 */
#define MD_STACK_GROWS_DOWN

#elif defined (QNX)	/* Panagiotis E. Hadjidoukas */

#define MD_STACK_GROWS_DOWN

#else
#error Unknown OS
#endif /* OS */

#endif /* !__ST_MD_H__ */

