#ifndef __UTH_H__
#define __UTH_H__

/*
 * This file is derived directly from the State Threads library, 
 * modified extensively by Panagiotis E. Hadjidoukas for UthLib. 
 */

/*#include <uth_opt.h>*/

typedef void *uth_t;

#ifdef __cplusplus
extern "C" {
#endif

/* Primary API */
extern int uth_init(int stacksize);
extern int uth_vp_init(int vp, void *arg);
extern int uth_get_vpid(void);
extern uth_t uth_create(void (*start)(void *arg), void *arg);
void uth_reinit(uth_t thread, void (*start)(void *arg), void *arg);
extern void uth_delete(uth_t t);
extern void uth_switchto(uth_t t1, uth_t t2);
extern uth_t uth_self(void);
extern void *uth_getarg(uth_t thread);
extern void uth_setarg(uth_t thread, void *arg);
extern double uth_gettime(void);

/* Extended API */
extern void uth_switchto_ex(int vp, uth_t t1, uth_t t2);
extern uth_t uth_self_ex(int vp);
extern void *uth_getarg_ex(int vp);


/* Advanced Feature */
extern void uth_setcontext(uth_t thread, void *ctx, int size);

extern void uth_stats(void);
#ifdef __cplusplus
}
#endif

#endif /* !__UTH_H__ */


